# 文字コードはＵＴＦ－８、改行コードはＬＦのみ
# $Id: HTML.pm 64 2008-11-15 10:28:34Z umezawa $

package KotoriBot::Plugin::URIInfo::HTML;

use strict;
use warnings;
use utf8;

use HTML::TokeParser;

use KotoriBot::Plugin;

our @ISA = qw(KotoriBot::Plugin);

sub initialize {
	my($self) = @_;

	my $uriinfo = $self->{channel}->plugin("KotoriBot::Plugin::URIInfo");
	if ($uriinfo) {
		$uriinfo->add_output_plugin($self, qr/.*/, qr!(?:text|application)/x?html(?:\+xml)?!);
	}
}

sub output_content {
	my($self, $context, $content, $ct) = @_;

	my $title = undef;
	my $parser = HTML::TokeParser->new(\$content);
	if  ($parser->get_tag("title")) {
		$title =  $parser->get_text();
	}

	$context->notice_redirects();
	$context->notice($title, "(Untitled Document)");
}

###############################################################################

return 1;
